/*
 * VariableInfo.java
 * 
 * Copyright (c) 1999 by Free Software Foundation, Inc.
 * Written by Wes Biggs (wes@cacas.org)
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation, version 2. (see COPYING.LIB)
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation  
 * Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307 USA
 */

package javax.servlet.jsp.tagext;

public class VariableInfo {
    public static final int NESTED = 0;
    public static final int AT_BEGIN = 1;
    public static final int AT_END = 2;

    private String className;
    private boolean declare;
    private String varName;
    private int scope;

    public VariableInfo(String varName, String className, boolean declare,
			int scope) {
	this.varName = varName;
	this.className = className;
	this.declare = declare;
	this.scope = scope; 
    }

    public String getClassName() { return className; }
    public String getVarName() { return varName; }
    public int getScope() { return scope; }
    public boolean getDeclare() { return declare; }
}
